# Author:   cBox
# Email:    william@jwawa.com
#
# 2002.11

import re, string

class ChineseSplitter:

	def __init__(self, insrc, stop_word_dic={}, encoding=''):
		self.isrc = insrc
		self.encode = ''
		try:
			self.isrc = unicode(insrc, 'utf8')
			self.encode = 'utf8'
		except:
			pass
		self.src = []
		if not stop_word_dic:
			stop_word_dic = {}
		if self.encode:
			split = re.split('([\x80-\xFF][\x80-\xFF][\x80-\xFF])|[\s\*\-\\0-9\_\^\~\<\>]+', self.isrc.encode('utf8'))
		else:
			split = re.split('([\x80-\xFF][\x80-\xFF])|[\s\*\-\\0-9\_\^\~\<\>]+', self.isrc)
		for k in split:
			if k:
				k = string.lower(k)
				if k and len(k) > 1 and k not in stop_word_dic.keys():
					self.src.append(k)

	def __getslice__(self, a, b):
		return self.src[a:b]

	def __getitem__(self, a):
		return self.src[a]

	def __len__(self):
		return len(self.src)

	def indexes(self, a):
		res =[]
		for i in range(len(self.src)):
			if self.src[i]==a:
				res.append(i)
		return res

	def pos(self, a):
		s = self.src[a]
		m = re.search(s, self.isrc)
		return m.span()
