# Author:   cBox
# Email:    william@jwawa.com
#
# 2002.11

from Products.PluginIndexes.TextIndex import Splitter

Splitter.availableSplitters = (
  ("ChineseSplitter" , "Zope Default Splitter"),
  ("ISO_8859_1_Splitter" , "Werner Strobls ISO-8859-1 Splitter"),
  ("UnicodeSplitter" , "Unicode-aware splitter"),
  ('ChineseSplitter', 'Chinese Splitter')
)

Splitter.splitterNames = map(lambda x: x[0], Splitter.availableSplitters)

def getSplitter(name=None):

    if not name in Splitter.splitterNames and name:
        raise exceptions.RuntimeError, "No such splitter '%s'" % name

    if not name: name = Splitter.splitterNames[0]

    if not vars().has_key(name) and name == 'ChineseSplitter':
        exec( "from %s.%s import %s" % (name, name, name))

    if not vars().has_key(name):
        exec( "from Products.PluginIndexes.TextIndex.Splitter.%s.%s import %s" % (name, name, name))

    return vars()[name]

Splitter.getSplitter = getSplitter
